// generated by Fast Light User Interface Designer (fluid) version 1.0109

#include "TrackEditorUI.h"
#include <FL/Fl_File_Chooser.H>
#include "ScException.h"
#include "TextConstants.h"

void TrackEditorUI::cb_newMap_i(Fl_Menu_*, void*) {
  if (!check_save()) return;
newTrackDialog->show();
}
void TrackEditorUI::cb_newMap(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_newMap_i(o,v);
}

void TrackEditorUI::cb_open_i(Fl_Menu_*, void*) {
  if (!check_save()) return;

  char *newfile = fl_file_chooser("Open File?", "*.xml", NULL);
  //printf("file: %s\n", newfile);
  if (newfile != NULL) {
     try { trackView->loadMap(newfile); }
     catch (ScException e) {
     	e.printMsg();
        fl_alert("Failed to open file %s\n", newfile);
        return;
     }
     strncpy(filename, newfile, 255);
     mainWindow->label(filename);
  };
}
void TrackEditorUI::cb_open(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_open_i(o,v);
}

void TrackEditorUI::cb_import_i(Fl_Menu_*, void*) {
  if (!check_save()) return;

  const char *newfile = fl_file_chooser("Import Image File?", "*.{jpg,png,bmp,pnm,pbm,pgm,ppm}", NULL);
  if (newfile != NULL) {
     trackView->resetImportImageDialog(newfile);
     importImageDialog->show();
   };
}
void TrackEditorUI::cb_import(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_import_i(o,v);
}

void TrackEditorUI::cb_save_i(Fl_Menu_*, void*) {
  if (filename[0] == '\0') {
  // No filename - get one!
  cb_saveAs_i(0,0);
  return;
 }
 else {
  try { trackView->saveMap(filename); }
  catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to save file %s", filename);
  }
 };
}
void TrackEditorUI::cb_save(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_save_i(o,v);
}

void TrackEditorUI::cb_saveAs_i(Fl_Menu_*, void*) {
  char *newfile;

 newfile = fl_file_chooser("Save File As?", "*.xml", filename);
 if (newfile != NULL) {
  try { trackView->saveMap(newfile); }
  catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to save file %s", newfile);
   return;
  }
  strncpy(filename, newfile, 255);
  mainWindow->label(filename);
 };
}
void TrackEditorUI::cb_saveAs(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_saveAs_i(o,v);
}

void TrackEditorUI::cb_install_i(Fl_Menu_*, void*) {
  if (filename[0] != '\0')
   trackView->installMap(filename);
else
   fl_alert("Save map first.");
}
void TrackEditorUI::cb_install(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_install_i(o,v);
}

void TrackEditorUI::cb_uninstall_i(Fl_Menu_*, void*) {
  if (filename[0] != '\0')
   trackView->uninstallMap(filename);
else
   fl_alert("Open map first.");
}
void TrackEditorUI::cb_uninstall(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_uninstall_i(o,v);
}

void TrackEditorUI::cb_quit_i(Fl_Menu_*, void*) {
  if (changed && !check_save())
 return;

 exit(0);
}
void TrackEditorUI::cb_quit(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_quit_i(o,v);
}

void TrackEditorUI::cb_draw_i(Fl_Menu_*, void*) {
  trackView->setTool(kDrawTool);
}
void TrackEditorUI::cb_draw(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_draw_i(o,v);
}

void TrackEditorUI::cb_path_i(Fl_Menu_*, void*) {
  trackView->setTool(kPathTool);
pathMenuItem->setonly();
}
void TrackEditorUI::cb_path(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_path_i(o,v);
}

void TrackEditorUI::cb_startline_i(Fl_Menu_*, void*) {
  trackView->setTool(kStartlineTool);
startlineMenuItem->setonly();
}
void TrackEditorUI::cb_startline(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_startline_i(o,v);
}

void TrackEditorUI::cb_scroll_i(Fl_Menu_*, void*) {
  trackView->setTool(kScrollTool);
scrollMenuItem->setonly();
}
void TrackEditorUI::cb_scroll(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_scroll_i(o,v);
}

void TrackEditorUI::cb_road_i(Fl_Menu_*, void*) {
  trackView->setTile(kRoad);
}
void TrackEditorUI::cb_road(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_road_i(o,v);
}

void TrackEditorUI::cb_offroad_i(Fl_Menu_*, void*) {
  trackView->setTile(kOffroad);
}
void TrackEditorUI::cb_offroad(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_offroad_i(o,v);
}

void TrackEditorUI::cb_wall_i(Fl_Menu_*, void*) {
  trackView->setTile(kWall);
}
void TrackEditorUI::cb_wall(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_wall_i(o,v);
}

void TrackEditorUI::cb_about_i(Fl_Menu_*, void*) {
  aboutBox->show();
}
void TrackEditorUI::cb_about(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_about_i(o,v);
}

void TrackEditorUI::cb_help_i(Fl_Menu_*, void*) {
  helpWindow->show();
}
void TrackEditorUI::cb_help(Fl_Menu_* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_help_i(o,v);
}

Fl_Menu_Item TrackEditorUI::menu_mainMenuBar[] = {
 {"File", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"New...", 0x4006e,  (Fl_Callback*)TrackEditorUI::cb_newMap, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Open...", 0x4006f,  (Fl_Callback*)TrackEditorUI::cb_open, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Import From Image...", 0x40069,  (Fl_Callback*)TrackEditorUI::cb_import, 0, 128, FL_NORMAL_LABEL, 0, 14, 0},
 {"Save", 0x40073,  (Fl_Callback*)TrackEditorUI::cb_save, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Save As...", 0x50073,  (Fl_Callback*)TrackEditorUI::cb_saveAs, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Install Track", 0x50069,  (Fl_Callback*)TrackEditorUI::cb_install, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Uninstall Track", 0x50075,  (Fl_Callback*)TrackEditorUI::cb_uninstall, 0, 128, FL_NORMAL_LABEL, 0, 14, 0},
 {"Quit", 0x40071,  (Fl_Callback*)TrackEditorUI::cb_quit, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Tools", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Draw", 0x31,  (Fl_Callback*)TrackEditorUI::cb_draw, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Path", 0x32,  (Fl_Callback*)TrackEditorUI::cb_path, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Startline", 0x33,  (Fl_Callback*)TrackEditorUI::cb_startline, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Scroll", 0x34,  (Fl_Callback*)TrackEditorUI::cb_scroll, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Tiles", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Road", 0,  (Fl_Callback*)TrackEditorUI::cb_road, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Offroad", 0,  (Fl_Callback*)TrackEditorUI::cb_offroad, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Wall", 0,  (Fl_Callback*)TrackEditorUI::cb_wall, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Help", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"About toycars_track_editor...", 0,  (Fl_Callback*)TrackEditorUI::cb_about, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {"Help...", 0,  (Fl_Callback*)TrackEditorUI::cb_help, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* TrackEditorUI::fileMenu = TrackEditorUI::menu_mainMenuBar + 0;
Fl_Menu_Item* TrackEditorUI::newMap = TrackEditorUI::menu_mainMenuBar + 1;
Fl_Menu_Item* TrackEditorUI::open = TrackEditorUI::menu_mainMenuBar + 2;
Fl_Menu_Item* TrackEditorUI::import = TrackEditorUI::menu_mainMenuBar + 3;
Fl_Menu_Item* TrackEditorUI::save = TrackEditorUI::menu_mainMenuBar + 4;
Fl_Menu_Item* TrackEditorUI::saveAs = TrackEditorUI::menu_mainMenuBar + 5;
Fl_Menu_Item* TrackEditorUI::install = TrackEditorUI::menu_mainMenuBar + 6;
Fl_Menu_Item* TrackEditorUI::uninstall = TrackEditorUI::menu_mainMenuBar + 7;
Fl_Menu_Item* TrackEditorUI::quit = TrackEditorUI::menu_mainMenuBar + 8;
Fl_Menu_Item* TrackEditorUI::toolsMenu = TrackEditorUI::menu_mainMenuBar + 10;
Fl_Menu_Item* TrackEditorUI::draw = TrackEditorUI::menu_mainMenuBar + 11;
Fl_Menu_Item* TrackEditorUI::path = TrackEditorUI::menu_mainMenuBar + 12;
Fl_Menu_Item* TrackEditorUI::startline = TrackEditorUI::menu_mainMenuBar + 13;
Fl_Menu_Item* TrackEditorUI::scroll = TrackEditorUI::menu_mainMenuBar + 14;
Fl_Menu_Item* TrackEditorUI::tilesMenu = TrackEditorUI::menu_mainMenuBar + 16;
Fl_Menu_Item* TrackEditorUI::road = TrackEditorUI::menu_mainMenuBar + 17;
Fl_Menu_Item* TrackEditorUI::offroad = TrackEditorUI::menu_mainMenuBar + 18;
Fl_Menu_Item* TrackEditorUI::wall = TrackEditorUI::menu_mainMenuBar + 19;
Fl_Menu_Item* TrackEditorUI::helpMenu = TrackEditorUI::menu_mainMenuBar + 21;
Fl_Menu_Item* TrackEditorUI::about = TrackEditorUI::menu_mainMenuBar + 22;
Fl_Menu_Item* TrackEditorUI::help = TrackEditorUI::menu_mainMenuBar + 23;

void TrackEditorUI::cb_vertScroll_i(Fl_Scrollbar* o, void*) {
  trackView->setVertScrollFrac(o->value() / 10000.0);
}
void TrackEditorUI::cb_vertScroll(Fl_Scrollbar* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_vertScroll_i(o,v);
}

void TrackEditorUI::cb_horizScroll_i(Fl_Scrollbar* o, void*) {
  trackView->setHorizScrollFrac(o->value() / 10000.0);
}
void TrackEditorUI::cb_horizScroll(Fl_Scrollbar* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_horizScroll_i(o,v);
}

void TrackEditorUI::cb_OK_i(Fl_Return_Button*, void*) {
  //printf("width %d height %d\n", (int)widthInput->value(), (int)heightInput->value());
try { trackView->newMap((int)widthInput->value(), (int)heightInput->value()); }
catch (ScException e) {
   e.printMsg();
   fl_alert("Fatal error. Must quit now.");
   exit(1);
}
newTrackDialog->hide();
filename[0] = '\0';
mainWindow->label(filename);
}
void TrackEditorUI::cb_OK(Fl_Return_Button* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_OK_i(o,v);
}

void TrackEditorUI::cb_Cancel_i(Fl_Button*, void*) {
  importImageDialog->hide();
}
void TrackEditorUI::cb_Cancel(Fl_Button* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_Cancel_i(o,v);
}

void TrackEditorUI::cb_OK1_i(Fl_Return_Button*, void*) {
  try { trackView->importImage(importImageBox->getFilename()); }
catch (ScException e) {
   e.printMsg();
   fl_alert("Failed to import file %s\n", importImageBox->getFilename());
   importImageBox->hide();
   return;
}
filename[0] = '\0';
mainWindow->label(filename);
importImageDialog->hide();
}
void TrackEditorUI::cb_OK1(Fl_Return_Button* o, void* v) {
  ((TrackEditorUI*)(o->parent()->user_data()))->cb_OK1_i(o,v);
}

TrackEditorUI::TrackEditorUI() {
  { mainWindow = new Fl_Double_Window(800, 600);
    mainWindow->user_data((void*)(this));
    { mainMenuBar = new Fl_Menu_Bar(0, 0, 800, 20);
      { Fl_Menu_Item* o = &menu_mainMenuBar[11];
        drawMenuItem = o;
        o->setonly();
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[12];
        pathMenuItem = o;
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[13];
        startlineMenuItem = o;
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[14];
        scrollMenuItem = o;
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[17];
        roadMenuItem = o;
        o->setonly();
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[18];
        offroadMenuItem = o;
        o->setonly();
      }
      { Fl_Menu_Item* o = &menu_mainMenuBar[19];
        wallMenuItem = o;
        o->setonly();
      }
      mainMenuBar->menu(menu_mainMenuBar);
    } // Fl_Menu_Bar* mainMenuBar
    { trackView = new TrackView(0, 20, 780, 560, "This is the track_view");
      trackView->box(FL_NO_BOX);
      trackView->color(FL_BACKGROUND_COLOR);
      trackView->selection_color(FL_BACKGROUND_COLOR);
      trackView->labeltype(FL_NORMAL_LABEL);
      trackView->labelfont(0);
      trackView->labelsize(14);
      trackView->labelcolor(FL_FOREGROUND_COLOR);
      trackView->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      trackView->when(FL_WHEN_RELEASE);
      Fl_Group::current()->resizable(trackView);
    } // TrackView* trackView
    { vertScroll = new Fl_Scrollbar(780, 20, 20, 560);
      vertScroll->maximum(10000);
      vertScroll->Fl_Slider::value(10000);
      vertScroll->callback((Fl_Callback*)cb_vertScroll);
    } // Fl_Scrollbar* vertScroll
    { horizScroll = new Fl_Scrollbar(0, 580, 780, 20);
      horizScroll->type(1);
      horizScroll->maximum(10000);
      horizScroll->callback((Fl_Callback*)cb_horizScroll);
    } // Fl_Scrollbar* horizScroll
    mainWindow->end();
  } // Fl_Double_Window* mainWindow
  { newTrackDialog = new Fl_Double_Window(250, 100, "Enter Track Dimensions");
    newTrackDialog->user_data((void*)(this));
    { widthInput = new Fl_Value_Input(55, 15, 65, 25, "Width");
      widthInput->minimum(20);
      widthInput->maximum(400);
      widthInput->step(1);
      widthInput->value(80);
    } // Fl_Value_Input* widthInput
    { heightInput = new Fl_Value_Input(55, 55, 65, 25, "Height");
      heightInput->minimum(20);
      heightInput->maximum(400);
      heightInput->step(1);
      heightInput->value(50);
    } // Fl_Value_Input* heightInput
    { Fl_Return_Button* o = new Fl_Return_Button(150, 55, 80, 25, "OK");
      o->callback((Fl_Callback*)cb_OK);
    } // Fl_Return_Button* o
    newTrackDialog->set_modal();
    newTrackDialog->end();
  } // Fl_Double_Window* newTrackDialog
  { importImageDialog = new Fl_Double_Window(376, 255, "Select Colour Mapping");
    importImageDialog->user_data((void*)(this));
    { importImageBox = new ImportImageBox(0, 0, 255, 255);
      importImageBox->box(FL_NO_BOX);
      importImageBox->color(FL_BACKGROUND_COLOR);
      importImageBox->selection_color(FL_BACKGROUND_COLOR);
      importImageBox->labeltype(FL_NORMAL_LABEL);
      importImageBox->labelfont(0);
      importImageBox->labelsize(14);
      importImageBox->labelcolor(FL_FOREGROUND_COLOR);
      importImageBox->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      importImageBox->when(FL_WHEN_RELEASE);
    } // ImportImageBox* importImageBox
    { roadColourButton = new Fl_Light_Button(260, 5, 110, 25, "Road");
      roadColourButton->type(102);
      roadColourButton->labeltype(FL_ENGRAVED_LABEL);
    } // Fl_Light_Button* roadColourButton
    { offroadColourButton = new Fl_Light_Button(260, 35, 110, 25, "Offroad");
      offroadColourButton->type(102);
      offroadColourButton->labeltype(FL_ENGRAVED_LABEL);
    } // Fl_Light_Button* offroadColourButton
    { wallColourButton = new Fl_Light_Button(260, 65, 110, 25, "Wall");
      wallColourButton->type(102);
      wallColourButton->labeltype(FL_ENGRAVED_LABEL);
    } // Fl_Light_Button* wallColourButton
    { Fl_Button* o = new Fl_Button(260, 185, 110, 25, "Cancel");
      o->callback((Fl_Callback*)cb_Cancel);
    } // Fl_Button* o
    { Fl_Return_Button* o = new Fl_Return_Button(260, 215, 110, 25, "OK");
      o->callback((Fl_Callback*)cb_OK1);
    } // Fl_Return_Button* o
    importImageDialog->set_modal();
    importImageDialog->end();
  } // Fl_Double_Window* importImageDialog
  { aboutBox = new Fl_Double_Window(250, 205, "About");
    aboutBox->user_data((void*)(this));
    { Fl_Text_Display* o = aboutDisplay = new Fl_Text_Display(25, 20, 200, 160);
      Fl_Text_Buffer *buf = new Fl_Text_Buffer(0);
      buf->append(kAboutBoxText);
      o->buffer(buf);
    } // Fl_Text_Display* aboutDisplay
    aboutBox->set_modal();
    aboutBox->end();
  } // Fl_Double_Window* aboutBox
  { helpWindow = new Fl_Double_Window(512, 384, "Help");
    helpWindow->user_data((void*)(this));
    { Fl_Text_Display* o = helpDisplay = new Fl_Text_Display(20, 20, 472, 344);
      helpDisplay->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
      Fl_Text_Buffer *buf = new Fl_Text_Buffer(0);
      buf->append(kHelpText);
      o->buffer(buf);
      o->wrap_mode(1,70);
    } // Fl_Text_Display* helpDisplay
    helpWindow->end();
    helpWindow->resizable(helpWindow);
  } // Fl_Double_Window* helpWindow
  changed = false;
  filename[0] = '\0';
  trackView->setTool(kDrawTool);
  trackView->setTile(kRoad);
  trackView->setUI(this);
  mainWindow->label(filename);
  importImageBox->setBtns(roadColourButton, offroadColourButton, wallColourButton);
  
  startlineMenuItem->setonly();
  scrollMenuItem->setonly();
  pathMenuItem->setonly();
  drawMenuItem->setonly();
  
  offroadMenuItem->setonly();
  wallMenuItem->setonly();
  roadMenuItem->setonly();
}

void TrackEditorUI::show(int argc, char **argv) {
  mainWindow->show(argc, argv);
}

void TrackEditorUI::setChanged(bool val) {
  changed = val;
}

int TrackEditorUI::check_save() {
  if (!changed) return 1;

  int r = fl_choice("The current file has not been saved.\n"
                    "Would you like to save it now?",
                    "Cancel", "Save", "Discard");

  if (r == 1) {
    cb_save_i(0,0); // Save the file...
    return !changed;
  }

  return (r == 2) ? 1 : 0;
}
